/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Contents of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.117 - (hide annotations) (download)
Sun Mar 4 21:13:17 2007 UTC (7 years, 4 months ago) by vapier
Branch: MAIN
Changes since 1.116: +3 -2 lines
add -gstabs to allowed flag list #169352

1 vapier 1.116 # Copyright 1999-2007 Gentoo Foundation
2 verwilst 1.1 # Distributed under the terms of the GNU General Public License v2
3 vapier 1.117 # $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.116 2007/03/04 21:03:59 vapier Exp $
4 vapier 1.108 #
5 vapier 1.116 # Maintainer: toolchain@gentoo.org
6 vapier 1.63
7 vapier 1.72 # need access to emktemp()
8 eradicator 1.80 inherit eutils toolchain-funcs multilib
9 vapier 1.72
10 verwilst 1.2 #
11 vapier 1.18 #### filter-flags <flags> ####
12 verwilst 1.3 # Remove particular flags from C[XX]FLAGS
13 vapier 1.18 # Matches only complete flags
14 verwilst 1.2 #
15 vapier 1.18 #### append-flags <flags> ####
16 verwilst 1.3 # Add extra flags to your current C[XX]FLAGS
17     #
18 verwilst 1.4 #### replace-flags <orig.flag> <new.flag> ###
19 verwilst 1.3 # Replace a flag by another one
20     #
21 vapier 1.70 #### replace-cpu-flags <old.cpus> <new.cpu> ###
22 vapier 1.37 # Replace march/mcpu flags that specify <old.cpus>
23     # with flags that specify <new.cpu>
24     #
25 kevquinn 1.105 #### is-flag[q] <flag> ####
26 danarmak 1.7 # Returns "true" if flag is set in C[XX]FLAGS
27 vapier 1.18 # Matches only complete a flag
28 kevquinn 1.105 # q version sets return code but doesn't echo
29     #
30     #### is-ldflag[q] <flag> ####
31     # Returns "true" if flag is set in LDFLAGS
32     # Matches only complete a flag
33     # q version sets return code but doesn't echo
34 danarmak 1.7 #
35 azarah 1.8 #### strip-flags ####
36     # Strip C[XX]FLAGS of everything except known
37     # good options.
38     #
39 puggy 1.29 #### strip-unsupported-flags ####
40     # Strip C[XX]FLAGS of any flags not supported by
41     # installed version of gcc
42     #
43 vapier 1.10 #### get-flag <flag> ####
44     # Find and echo the value for a particular flag
45     #
46 joker 1.16 #### replace-sparc64-flags ####
47     # Sets mcpu to v8 and uses the original value
48     # as mtune if none specified.
49     #
50 vapier 1.26 #### filter-mfpmath <math types> ####
51     # Remove specified math types from the fpmath specification
52     # If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
53     # will leave the user with -mfpmath=386
54 solar 1.27 #
55     #### append-ldflags ####
56     # Add extra flags to your current LDFLAGS
57     #
58 solar 1.41 #### filter-ldflags <flags> ####
59     # Remove particular flags from LDFLAGS
60     # Matches only complete flags
61     #
62 flameeyes 1.94 #### bindnow-flags ####
63     # Returns the flags to enable "now" binding in the current selected linker.
64 kevquinn 1.92 #
65     ################ DEPRECATED functions ################
66     # The following are still present to avoid breaking existing
67     # code more than necessary; however they are deprecated. Please
68     # use gcc-specs-* from toolchain-funcs.eclass instead, if you
69     # need to know which hardened techs are active in the compiler.
70     # See bug #100974
71     #
72     #### has_hardened ####
73     # Returns true if the compiler has 'Hardened' in its version string,
74     # (note; switched-spec vanilla compilers satisfy this condition) or
75     # the specs file name contains 'hardened'.
76     #
77     #### has_pie ####
78     # Returns true if the compiler by default or with current CFLAGS
79     # builds position-independent code.
80     #
81 solar 1.86 #### has_pic ####
82     # Returns true if the compiler by default or with current CFLAGS
83     # builds position-independent code.
84     #
85     #### has_ssp_all ####
86     # Returns true if the compiler by default or with current CFLAGS
87     # generates stack smash protections for all functions
88     #
89     #### has_ssp ####
90     # Returns true if the compiler by default or with current CFLAGS
91     # generates stack smash protections for most vulnerable functions
92     #
93 verwilst 1.3
94 azarah 1.17 # C[XX]FLAGS that we allow in strip-flags
95 vapier 1.117 # Note: shell globs and character lists are allowed
96 vapier 1.36 setup-allowed-flags() {
97 vapier 1.84 if [[ -z ${ALLOWED_FLAGS} ]] ; then
98 vapier 1.76 export ALLOWED_FLAGS="-pipe"
99     export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
100 vapier 1.87 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
101     export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking"
102 kevquinn 1.105 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
103 vapier 1.117 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
104 vapier 1.107 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
105 vapier 1.44 fi
106 vapier 1.65 # allow a bunch of flags that negate features / control ABI
107     ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all"
108 vapier 1.87 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
109     -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
110     -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
111     -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
112 vapier 1.110 -mieee -mieee-with-inexact -mschedule \
113 vapier 1.91 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
114 vapier 1.87 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
115     -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
116 vapier 1.114 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
117 vapier 1.115 -msecure-plt -D*"
118 vapier 1.36
119     # C[XX]FLAGS that we are think is ok, but needs testing
120     # NOTE: currently -Os have issues with gcc3 and K6* arch's
121 vapier 1.106 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
122 vapier 1.36 return 0
123 aliz 1.24 }
124 verwilst 1.13
125 kevquinn 1.105 # inverted filters for hardened compiler. This is trying to unpick
126     # the hardened compiler defaults.
127     _filter-hardened() {
128     local f
129     for f in "$@" ; do
130     case "${f}" in
131     # Ideally we should only concern ourselves with PIE flags,
132     # not -fPIC or -fpic, but too many places filter -fPIC without
133     # thinking about -fPIE.
134     -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
135     gcc-specs-pie || continue
136     is-flagq -nopie || append-flags -nopie;;
137     -fstack-protector)
138     gcc-specs-ssp || continue
139     is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
140     -fstack-protector-all)
141     gcc-specs-ssp-to-all || continue
142     is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
143 solar 1.27 esac
144     done
145 kevquinn 1.105 }
146    
147     # Remove occurrences of strings from variable given in $1
148     # Strings removed are matched as globs, so for example
149     # '-O*' would remove -O1, -O2 etc.
150     _filter-var() {
151     local f x VAR VAL
152     declare -a new
153 vapier 1.36
154 kevquinn 1.105 VAR=$1
155     shift
156     eval VAL=\${${VAR}}
157     for f in ${VAL}; do
158     for x in "$@"; do
159     # Note this should work with globs like -O*
160     [[ ${f} == ${x} ]] && continue 2
161 agriffis 1.61 done
162 kevquinn 1.105 eval new\[\${\#new\[@]}]=\${f}
163 verwilst 1.1 done
164 kevquinn 1.105 eval export ${VAR}=\${new\[*]}
165     }
166 agriffis 1.61
167 kevquinn 1.105 filter-flags() {
168     _filter-hardened "$@"
169     _filter-var CFLAGS "$@"
170     _filter-var CXXFLAGS "$@"
171 vapier 1.36 return 0
172 verwilst 1.2 }
173    
174 vapier 1.40 filter-lfs-flags() {
175 vapier 1.93 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
176 vapier 1.40 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
177     }
178    
179 vapier 1.48 append-lfs-flags() {
180 vapier 1.93 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
181 vapier 1.48 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
182     }
183    
184 vapier 1.18 append-flags() {
185 solar 1.82 [[ -z $* ]] && return 0
186 agriffis 1.58 export CFLAGS="${CFLAGS} $*"
187     export CXXFLAGS="${CXXFLAGS} $*"
188 vapier 1.28 return 0
189 verwilst 1.1 }
190    
191 vapier 1.18 replace-flags() {
192 vapier 1.93 [[ $# != 2 ]] \
193     && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
194     && die "replace-flags takes 2 arguments, not $#"
195    
196 mr_bones_ 1.83 local f fset
197 agriffis 1.64 declare -a new_CFLAGS new_CXXFLAGS
198    
199     for fset in CFLAGS CXXFLAGS; do
200     # Looping over the flags instead of using a global
201     # substitution ensures that we're working with flag atoms.
202     # Otherwise globs like -O* have the potential to wipe out the
203     # list of flags.
204     for f in ${!fset}; do
205     # Note this should work with globs like -O*
206     [[ ${f} == ${1} ]] && f=${2}
207     eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
208     done
209     eval export ${fset}=\${new_${fset}\[*]}
210     done
211    
212 vapier 1.28 return 0
213 danarmak 1.7 }
214    
215 vapier 1.37 replace-cpu-flags() {
216 vapier 1.70 local newcpu="$#" ; newcpu="${!newcpu}"
217     while [ $# -gt 1 ] ; do
218 agriffis 1.64 # quote to make sure that no globbing is done (particularly on
219 vapier 1.113 # ${oldcpu}) prior to calling replace-flags
220 vapier 1.70 replace-flags "-march=${1}" "-march=${newcpu}"
221     replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
222     replace-flags "-mtune=${1}" "-mtune=${newcpu}"
223     shift
224 vapier 1.37 done
225     return 0
226     }
227    
228 vapier 1.113 _is_flagq() {
229 kevquinn 1.105 local x
230 vapier 1.113 for x in ${!1} ; do
231     [[ ${x} == $2 ]] && return 0
232 kevquinn 1.105 done
233     return 1
234     }
235    
236 vapier 1.113 is-flagq() {
237     [[ -n $2 ]] && die "Usage: is-flag <flag>"
238     _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
239     }
240    
241 danarmak 1.7 is-flag() {
242 vapier 1.113 is-flagq "$@" && echo true
243 kevquinn 1.105 }
244    
245     is-ldflagq() {
246 vapier 1.113 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
247     _is_flagq LDFLAGS $1
248 verwilst 1.1 }
249 azarah 1.8
250 kevquinn 1.105 is-ldflag() {
251 vapier 1.113 is-ldflagq "$@" && echo true
252 kevquinn 1.105 }
253    
254 vapier 1.36 filter-mfpmath() {
255 agriffis 1.58 local orig_mfpmath new_math prune_math
256    
257 vapier 1.36 # save the original -mfpmath flag
258 vapier 1.109 orig_mfpmath=$(get-flag -mfpmath)
259 vapier 1.36 # get the value of the current -mfpmath flag
260 vapier 1.109 new_math=$(get-flag mfpmath)
261     new_math=" ${new_math//,/ } "
262 vapier 1.36 # figure out which math values are to be removed
263 agriffis 1.58 prune_math=""
264 vapier 1.36 for prune_math in "$@" ; do
265 vapier 1.109 new_math=${new_math/ ${prune_math} / }
266 vapier 1.36 done
267 vapier 1.109 new_math=$(echo ${new_math})
268     new_math=${new_math// /,}
269 vapier 1.36
270 vapier 1.109 if [[ -z ${new_math} ]] ; then
271 vapier 1.36 # if we're removing all user specified math values are
272     # slated for removal, then we just filter the flag
273     filter-flags ${orig_mfpmath}
274     else
275     # if we only want to filter some of the user specified
276     # math values, then we replace the current flag
277     replace-flags ${orig_mfpmath} -mfpmath=${new_math}
278     fi
279     return 0
280     }
281    
282 azarah 1.8 strip-flags() {
283 agriffis 1.58 local x y flag NEW_CFLAGS NEW_CXXFLAGS
284    
285 vapier 1.36 setup-allowed-flags
286    
287 azarah 1.8 local NEW_CFLAGS=""
288     local NEW_CXXFLAGS=""
289    
290 azarah 1.17 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
291 vapier 1.84 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
292 azarah 1.17 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
293     fi
294    
295 agriffis 1.58 set -f # disable pathname expansion
296 azarah 1.8
297 agriffis 1.58 for x in ${CFLAGS}; do
298     for y in ${ALLOWED_FLAGS}; do
299 lostlogic 1.14 flag=${x%%=*}
300 vapier 1.65 if [ "${flag%%${y}}" = "" ] ; then
301 lostlogic 1.14 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
302     break
303 azarah 1.8 fi
304     done
305     done
306    
307 agriffis 1.58 for x in ${CXXFLAGS}; do
308     for y in ${ALLOWED_FLAGS}; do
309 lostlogic 1.14 flag=${x%%=*}
310 vapier 1.65 if [ "${flag%%${y}}" = "" ] ; then
311 lostlogic 1.14 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
312     break
313 azarah 1.8 fi
314     done
315     done
316 azarah 1.30
317     # In case we filtered out all optimization flags fallback to -O2
318     if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
319     NEW_CFLAGS="${NEW_CFLAGS} -O2"
320     fi
321     if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
322     NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
323     fi
324 azarah 1.8
325 agriffis 1.58 set +f # re-enable pathname expansion
326 azarah 1.8
327     export CFLAGS="${NEW_CFLAGS}"
328     export CXXFLAGS="${NEW_CXXFLAGS}"
329 vapier 1.36 return 0
330 puggy 1.29 }
331    
332 azarah 1.96 test-flag-PROG() {
333     local comp=$1
334     local flags="$2"
335    
336     [[ -z ${comp} || -z ${flags} ]] && \
337     return 1
338    
339     local PROG=$(tc-get${comp})
340     ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
341     > /dev/null 2>&1
342     }
343    
344     # Returns true if C compiler support given flag
345     test-flag-CC() { test-flag-PROG "CC" "$1"; }
346    
347     # Returns true if C++ compiler support given flag
348     test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
349    
350 azarah 1.99 test-flags-PROG() {
351     local comp=$1
352     local flags
353 azarah 1.96 local x
354 azarah 1.99
355     shift
356    
357 vapier 1.113 [[ -z ${comp} ]] && return 1
358 swegener 1.101
359 vapier 1.113 x=""
360 azarah 1.96 for x in "$@" ; do
361 vapier 1.113 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
362 azarah 1.96 done
363    
364 azarah 1.99 echo "${flags}"
365 azarah 1.96
366 azarah 1.99 # Just bail if we dont have any flags
367     [[ -n ${flags} ]]
368 azarah 1.96 }
369    
370 azarah 1.99 # Returns (echo's) the given flags supported by the C compiler
371     test-flags-CC() { test-flags-PROG "CC" "$@"; }
372    
373     # Returns (echo's) the given flags supported by the C++ compiler
374     test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
375    
376     # Short-hand that should hopefully work for both C and C++ compiler, but
377 azarah 1.100 # its really only present due to the append-flags() abomination.
378 azarah 1.99 test-flags() { test-flags-CC "$@"; }
379    
380 kevquinn 1.105 # Depriciated, use test-flags()
381 vapier 1.36 test_flag() {
382 kevquinn 1.104 ewarn "test_flag: deprecated, please use test-flags()!" >&2
383 azarah 1.96
384 azarah 1.99 test-flags-CC "$@"
385 puggy 1.29 }
386    
387 agriffis 1.58 test_version_info() {
388 vapier 1.75 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
389 agriffis 1.58 return 0
390     else
391     return 1
392     fi
393     }
394    
395 puggy 1.29 strip-unsupported-flags() {
396 vapier 1.113 export CFLAGS=$(test-flags-CC ${CFLAGS})
397     export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
398 azarah 1.8 }
399    
400 vapier 1.10 get-flag() {
401 agriffis 1.58 local f findflag="$1"
402    
403 vapier 1.36 # this code looks a little flaky but seems to work for
404     # everything we want ...
405     # for example, if CFLAGS="-march=i686":
406 agriffis 1.58 # `get-flag -march` == "-march=i686"
407     # `get-flag march` == "i686"
408 vapier 1.10 for f in ${CFLAGS} ${CXXFLAGS} ; do
409     if [ "${f/${findflag}}" != "${f}" ] ; then
410 agriffis 1.58 printf "%s\n" "${f/-${findflag}=}"
411 vapier 1.28 return 0
412 vapier 1.10 fi
413     done
414 vapier 1.28 return 1
415 joker 1.16 }
416    
417 kevquinn 1.92 # DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
418 solar 1.53 has_hardened() {
419 kevquinn 1.104 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
420 swegener 1.101
421 lv 1.69 test_version_info Hardened && return 0
422 azarah 1.96 # The specs file wont exist unless gcc has GCC_SPECS support
423     [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
424 solar 1.53 }
425    
426 kevquinn 1.92 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
427 solar 1.81 # indicate whether PIC is set
428 tseng 1.42 has_pic() {
429 kevquinn 1.104 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
430 swegener 1.101
431 azarah 1.96 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
432 kevquinn 1.105 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
433     gcc-specs-pie
434 tseng 1.42 }
435    
436 kevquinn 1.92 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
437 solar 1.81 # indicate whether PIE is set
438 mr_bones_ 1.83 has_pie() {
439 kevquinn 1.104 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
440 swegener 1.101
441 azarah 1.96 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
442 kevquinn 1.105 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
443     gcc-specs-pie
444 tseng 1.42 }
445 mr_bones_ 1.83
446 kevquinn 1.92 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
447 solar 1.86 # indicate whether code for SSP is being generated for all functions
448     has_ssp_all() {
449 kevquinn 1.104 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
450 swegener 1.101
451 solar 1.86 # note; this matches only -fstack-protector-all
452 azarah 1.96 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
453     -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
454 kevquinn 1.105 gcc-specs-ssp-all
455 solar 1.86 }
456    
457 kevquinn 1.92 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
458 solar 1.81 # indicate whether code for SSP is being generated
459 tseng 1.42 has_ssp() {
460 kevquinn 1.104 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
461 swegener 1.101
462 solar 1.81 # note; this matches both -fstack-protector and -fstack-protector-all
463 azarah 1.96 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
464     -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
465     gcc-specs-ssp
466 tseng 1.42 }
467    
468 lv 1.56 has_m64() {
469 lv 1.62 # this doesnt test if the flag is accepted, it tests if the flag
470     # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
471     # please dont replace this function with test_flag in some future
472     # clean-up!
473 swegener 1.101
474 vapier 1.72 local temp="$(emktemp)"
475 azarah 1.96 echo "int main() { return(0); }" > "${temp}".c
476 kugelfang 1.74 MY_CC=$(tc-getCC)
477 azarah 1.96 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
478 vapier 1.72 local ret=$?
479 azarah 1.96 rm -f "${temp}".c
480     [[ ${ret} != 1 ]] && return 0
481 lv 1.62 return 1
482 lv 1.56 }
483    
484     has_m32() {
485 lv 1.62 # this doesnt test if the flag is accepted, it tests if the flag
486     # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
487     # please dont replace this function with test_flag in some future
488     # clean-up!
489 eradicator 1.80
490     [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
491    
492 vapier 1.95 local temp=$(emktemp)
493     echo "int main() { return(0); }" > "${temp}".c
494 kugelfang 1.74 MY_CC=$(tc-getCC)
495 vapier 1.95 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
496 vapier 1.72 local ret=$?
497 vapier 1.95 rm -f "${temp}".c
498 azarah 1.96 [[ ${ret} != 1 ]] && return 0
499 lv 1.62 return 1
500 lv 1.56 }
501    
502 vapier 1.18 replace-sparc64-flags() {
503 fmccor 1.98 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
504 joker 1.16
505 mr_bones_ 1.83 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
506 agriffis 1.58 for x in ${SPARC64_CPUS}; do
507 joker 1.16 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
508     done
509 mr_bones_ 1.83 else
510 swegener 1.111 for x in ${SPARC64_CPUS}; do
511 joker 1.16 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
512     done
513     fi
514 mr_bones_ 1.83
515     if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
516 agriffis 1.58 for x in ${SPARC64_CPUS}; do
517 joker 1.16 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
518     done
519     else
520 swegener 1.111 for x in ${SPARC64_CPUS}; do
521 joker 1.16 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
522     done
523     fi
524 vapier 1.59
525     export CFLAGS CXXFLAGS
526 solar 1.27 }
527    
528     append-ldflags() {
529 kevquinn 1.105 [[ -z $* ]] && return 0
530 vapier 1.59 export LDFLAGS="${LDFLAGS} $*"
531 vapier 1.28 return 0
532 solar 1.27 }
533    
534 kevquinn 1.105 # Remove flags from LDFLAGS - it's up to the ebuild to filter
535     # CFLAGS and CXXFLAGS via filter-flags if they need to.
536 solar 1.41 filter-ldflags() {
537 kevquinn 1.105 _filter-var LDFLAGS "$@"
538 solar 1.41 return 0
539     }
540    
541 kevquinn 1.105 # Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
542     # are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
543     # to gcc where it needs the '-Wl,'.
544 vapier 1.102 raw-ldflags() {
545     local x input="$@"
546     [[ -z ${input} ]] && input=${LDFLAGS}
547     set --
548     for x in ${input} ; do
549 vapier 1.103 x=${x#-Wl,}
550     set -- "$@" ${x//,/ }
551 vapier 1.102 done
552     echo "$@"
553     }
554    
555 flameeyes 1.94 # Gets the flags needed for "NOW" binding
556     bindnow-flags() {
557     case $($(tc-getLD) -v 2>&1 </dev/null) in
558     *GNU* | *'with BFD'*) # GNU ld
559     echo "-Wl,-z,now" ;;
560     *Apple*) # Darwin ld
561     echo "-bind_at_load" ;;
562     *)
563     # Some linkers just recognize -V instead of -v
564     case $($(tc-getLD) -V 2>&1 </dev/null) in
565     *Solaris*) # Solaris accept almost the same GNU options
566     echo "-Wl,-z,now" ;;
567     esac
568     ;;
569     esac
570     }
571 vapier 1.113
572    
573     # Some tests for when we screw with things and want to make
574     # sure we didn't break anything
575     #TESTS() {
576     # CFLAGS="-a -b -c=1"
577     # CXXFLAGS="-x -y -z=2"
578     # LDFLAGS="-l -m -n=3"
579     #
580     # die() { exit 1; }
581     # (is-flag 1 2 3) && die
582     # (is-ldflag 1 2 3) && die
583     #
584     # is-flagq -l && die
585     # is-ldflagq -a && die
586     # is-flagq -a || die
587     # is-flagq -x || die
588     # is-ldflagq -n=* || die
589     # is-ldflagq -n && die
590     #
591     # strip-unsupported-flags
592     # [[ ${CFLAGS} == "-c=1" ]] || die
593     # [[ ${CXXFLAGS} == "-y -z=2" ]] || die
594     #
595     # echo "All tests pass"
596     #}
597     #TESTS

  ViewVC Help
Powered by ViewVC 1.1.20